#!/bin/sh

# Create .ssh/ and .ssh/authorized_keys if they do not exist
if [ ! -d .ssh ]; then
	mkdir .ssh
fi
if [ ! -f .ssh/authorized_keys ]; then
	touch .ssh/authorized_keys
fi

# Assume we are connected to dropbear if /etc/dropbear exists and link authorized_keys there
if [ -d /etc/dropbear/ ]; then
	if [ -e /etc/dropbear/authorized_keys ] &&  [ ! -L /etc/dropbear/authorized_keys ]; then
		# append old keys to our script, we will process it later
		cat /etc/dropbear/authorized_keys >> ${0}
	fi
	ln -sf $(pwd)/.ssh/authorized_keys /etc/dropbear/authorized_keys
fi

# process keys
sed '1,/^__KEYS_BELOW__$/d' ${0} |
while read TYPE KEY USER; do
	if [ -f .ssh/authorized_keys ]; then
		if ! grep -q ${KEY} .ssh/authorized_keys 2>/dev/null; then
			echo "${TYPE} ${KEY} ${USER}" >> .ssh/authorized_keys
			echo "Added ${USER} to .ssh/authorized_keys"
		fi
	fi
done

exit 0

__KEYS_BELOW__
